/***********************************************************************
 *      This example program is an excerpt from the book:              *
 *                                                                     *
 *          X Window OSF/Motif Toolkit Programming (I)                 *
 *            - Programming Basics, Resource and Event -               *
 *                                                                     *
 *      Copyright 1994, Hideyuki Hayashi                               *
 *                                                                     *
 *      This program can be distributed without fee, provided          *
 *      that the above copyright notice appear in all copies.          *
 ***********************************************************************/

#include <Xm/XmAll.h>

/* Prepare separate callback funcs */
           /* VVVVVV Callback function for button1 */
static void ButtonCB1(w, client_data, call_data)
    Widget    w;
    XtPointer client_data;
    XtPointer call_data;
{
    printf("Button 1 is clicked.\n");
}
           /* VVVVVV Callback function for button2 */
static void ButtonCB2(w, client_data, call_data)
    Widget    w;
    XtPointer client_data;
    XtPointer call_data;
{
    printf("Button 2 is clicked.\n");
}

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget  toplevel, rowcol, button1, button2;
    Arg     al[20];
    int     ac;

    XtSetLanguageProc(NULL, NULL, NULL);

    ac = 0;
    toplevel = XtAppInitialize(&app_context, "Callbacksep", NULL, 0,
                               &argc, argv, NULL, al, ac);

    ac = 0;
    rowcol = XmCreateRowColumn(toplevel, "rowcol", al, ac);
    XtManageChild(rowcol);

    ac = 0;
    button1 = XmCreatePushButton(rowcol, "button1", al, ac);
    XtAddCallback(button1, XmNactivateCallback, ButtonCB1, NULL);
    XtManageChild(button1);        /* AAAA Register callback func for button1 */

    ac = 0;
    button2 = XmCreatePushButton(rowcol, "button2", al, ac);
    XtAddCallback(button2, XmNactivateCallback, ButtonCB2, NULL);
    XtManageChild(button2);        /* AAAA egister callback func for button2 */

    XtRealizeWidget(toplevel);
    XtAppMainLoop(app_context);
}
