/***********************************************************************
 *      This example program is an excerpt from the book:              *
 *                                                                     *
 *          X Window OSF/Motif Toolkit Programming (I)                 *
 *            - Programming Basics, Resource and Event -               *
 *                                                                     *
 *      Copyright 1994, Hideyuki Hayashi                               *
 *                                                                     *
 *      This program can be distributed without fee, provided          *
 *      that the above copyright notice appear in all copies.          *
 ***********************************************************************/

#include <Xm/XmAll.h>

static Widget toggle, text;

static void GetValuesCB(w, client_data, call_data)
    Widget    w;
    XtPointer client_data;
    XtPointer call_data;
{
    Boolean  state;
    char    *string;

    state = XmToggleButtonGetState(toggle); /* Get current toggle state */
    if (state) printf("Toggle is now ON.\n");
    else       printf("Toggle is now OFF.\n");

    string = XmTextFieldGetString(text); /* Get the entered text */
    printf("Entered text: %s\n", string);
    XtFree(string); /* Free if not necessary */
}

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget toplevel, rowcol, button;
    Arg    al[20];
    int    ac;

    XtSetLanguageProc(NULL, NULL, NULL);

    ac = 0;
    XtSetArg(al[ac], XmNmaxWidth, 400); ac++;
    XtSetArg(al[ac], XmNmaxHeight, 200); ac++;
    toplevel = XtAppInitialize(&app_context, "Getvalues", NULL, 0,
                               &argc, argv, NULL, al, ac);

    ac = 0;
    XtSetArg(al[ac], XmNmarginWidth, 20); ac++;
    XtSetArg(al[ac], XmNmarginHeight, 10); ac++;
    rowcol = XmCreateRowColumn(toplevel, "rowcol", al, ac);
    XtManageChild(rowcol);

    ac = 0;
    XtSetArg(al[ac], XmNset, True); ac++;
    toggle = XmCreateToggleButton(rowcol, "toggle", al, ac);
    XtManageChild(toggle);

    ac = 0;
    text = XmCreateTextField(rowcol, "text", al, ac);
    XtManageChild(text);

    ac = 0;
    button = XmCreatePushButton(rowcol, "button", al, ac);
    XtAddCallback(button, XmNactivateCallback, GetValuesCB, NULL);
    XtManageChild(button);

    XtRealizeWidget(toplevel);
    XtAppMainLoop(app_context);
}
